`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 04/09/2020 05:42:38 PM
// Design Name: 
// Module Name: Lab7_1
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module Lab7_1(
    f_crystal,
    rst,
    show_sec,
    ssd_ctl,
    D_ssd,
    mode,
    speedup
    );
    input f_crystal, rst, show_sec, mode, speedup;
    output [3:0]ssd_ctl;
    output [7:0]D_ssd;
    wire clk_1, clk_10, clk_100, clk_1000;
    wire [1:0]ssd_clk;
    wire [3:0]sec_0, sec_1, min_0, min_1, hr_0, hr_1;
    wire [3:0]hr_0_ver2, hr_1_ver2;
    reg [3:0]disp_0, disp_1, disp_2, disp_3;
    reg count_frq;
    wire [3:0]display;
    wire point;
    frq_div U0(
    .f_out(clk_1), // divided clock output
    .clk_100(clk_100),
    .clk_10(clk_10),
    .clk_1000(clk_1000),
    .ssd_clk(ssd_clk),
    .f_crystal(f_crystal), // global clock input
    .rst(rst) // active low reset
    );
    always @*
        if(speedup)
            count_frq = clk_1000;
        else
            count_frq = clk_10;
    Time U1(
    .clk(count_frq),
    .increase(1'd1),
    .reset(rst),
    .sec_0(sec_0),
    .sec_1(sec_1),
    .min_0(min_0),
    .min_1(min_1),
    .hr_0(hr_0),
    .hr_1(hr_1),
    .mode(mode)
    );
    hr_disp(
    .hr_0_ori(hr_0),
    .hr_1_ori(hr_1),
    .hr_0_mod(hr_0_ver2),
    .hr_1_mod(hr_1_ver2),
    .mode(mode)
    );
    always @*
        if(show_sec)
            begin
                disp_0 = sec_0;
                disp_1 = sec_1;
                disp_2 = 4'd0;
                disp_3 = 4'd0;
            end
        else
            begin
                disp_0 = min_0;
                disp_1 = min_1;
                disp_2 = hr_0_ver2;
                disp_3 = hr_1_ver2;
            end
    scan_ctl U2(
      .ssd_ctl(ssd_ctl), // ssd display control signal 
      .ssd_in0(disp_0), // output to ssd display
      .ssd_in1(disp_1),
      .ssd_in2(disp_2),
      .ssd_in3(disp_3),
      .ssd_in(display),
      .ssd_ctl_clk(ssd_clk),
      .point(point)  
    );
    Display_7_segment U3(.D_ssd(D_ssd), .i(display), .point(point));

endmodule
